%define version      6.7
%define release      20190320.1
%define rhel_version 8
%define rhcert_sitelib /usr/lib/python3.6/site-packages/rhcert/
%define rhcert_python python3

# disable shebang ambiguity errors
%undefine __brp_mangle_shebangs

# The behaviour of the rpm-build package for python files varies between
# releases.  Sometime in the FC4 timeframe it gained a file
# /usr/lib/rpm/brp-python-bytecompile which generates pyo and pyc files for py
# files, in a phase after the install.
# This macro is needed to turn this off, for building on FC4/RHEL5 and later:
%define byte_compiled_python 0

Name:           redhat-certification
Summary:        Red Hat Certification
Version:        %{version}
Release:        %{release}.el%{rhel_version}
Group:          Development/Tools
License:        GPLv2+
URL:			http://redhat.com
Source0:        %{name}-%{version}-%{release}.tar.bz2
# snapshot
Buildroot:      %{_tmppath}/%{name}-%{version}-root
BuildArch:	noarch
Obsoletes: rhcert-client, ccp-client
BuildRequires: %{rhcert_python}-devel
Requires: redhat-certification-backend = %{version}-%{release}
Requires: httpd
Requires: mod_wsgi
Requires: %{rhcert_python}-lxml
Requires: %{rhcert_python}-django >= 1.8
Requires(post): systemd
Requires(post): firewalld

# redhat-certification-backend subpackage
%package -n redhat-certification-backend
Summary:        Red Hat Hardware Test Suite Backend
Group:          Development/Tools
# for container certifications
Requires: %{rhcert_python}-magic
# for client listener: ps
Requires: procps
# rhcert.Test.collabRequest
Requires: %{rhcert_python}-requests
Requires: %{rhcert_python}-lxml

# redhat-certification-hardware subpackage
%package -n redhat-certification-hardware
Summary:        Red Hat Hardware Certification Test Suite
Group:          Development/Tools
Requires:       redhat-certification-backend >= %{version}
Requires:       lmbench, dt, httpd, nfs-utils, stress, gcc
Requires:       kernel-devel, kernel-headers
Requires:       kernel-abi-whitelists, policycoreutils, sos
Requires:       rfkill, pciutils
# require usbutils for lsusb except on s390x
%ifnarch s390x
Requires: usbutils, iw, NetworkManager
%endif
# require RHEL7 via kernel
Requires: kernel >= 3
Provides:       redhat-certification-hardware

# redhat-certification-hardware-preview subpackage
%package -n redhat-certification-hardware-preview
Summary:        Red Hat Hardware Test Suite Preview
Group:          Development/Tools
Requires:       redhat-certification-hardware >= %{version}
Requires:       qemu-kvm libvirt %{rhcert_python}-dbus
Requires:       kernel-abi-whitelists, policycoreutils, sos
Provides:       redhat-certification-preview

# redhat-certification-cloud subpackage
%package -n redhat-certification-cloud
Summary:        Red Hat Cloud Certification Test Suite
Group:          Development/Tools
Requires:       redhat-certification-backend >= %{version}
Requires:       nmap authconfig
Requires:       kernel-abi-whitelists, policycoreutils, sos
Provides:       stsclient-cloud-plugin, ccp-client
Obsoletes:      stsclient-cloud-plugin, ccp-client

# redhat-certification-openstack subpackage
%package -n redhat-certification-openstack
Summary: Red Hat OpenStack Platform Certification Test Suite
Group:          Development/Tools
Requires:       redhat-certification-backend >= %{version}
Requires:       %{rhcert_python}-jsonschema
Requires:       %{rhcert_python}-subunit
Requires:       rhosp-release
Requires:       kernel-abi-whitelists, policycoreutils, sos

# redhat-certification-baremetal subpackage
%package -n redhat-certification-baremetal
Summary: Red Hat Baremetal certification Test Suite
Group:          Development/Tools
Requires:       redhat-certification-backend >= %{version}
Requires:       kernel-abi-whitelists, policycoreutils, sos

%description
Red Hat Certification runs certification tests for Red Hat products
%description -n redhat-certification-backend
Red Hat Certification Backend runs certification tests for Red Hat products
%description -n redhat-certification-hardware
Red Hat Hardware Certification Test Suite
%description -n redhat-certification-hardware-preview
Red Hat Hardware Certification Test Suite Preview
%description -n redhat-certification-cloud
Red Hat CCSP Certification Test Suite
%description -n redhat-certification-openstack
Red Hat OpenStack Platform Certification Test Suite
%description -n redhat-certification-baremetal
Red Hat Baremetal certification Test Suite

%prep
%setup -q -c

%build
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
DESTDIR=$RPM_BUILD_ROOT RHCERT_RHEL_VERSION=%{rhel_version} RHCERT_RELEASE=20190320.1 RHCERT_PYTHON=/usr/bin/%{rhcert_python} RHCERT_SITE_LIB=%{rhcert_sitelib} make

%install
DESTDIR=$RPM_BUILD_ROOT RHCERT_RHEL_VERSION=%{rhel_version} RHCERT_RELEASE=20190320.1 RHCERT_PYTHON=/usr/bin/%{rhcert_python} RHCERT_SITE_LIB=%{rhcert_sitelib} make install

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%pre

%post
chcon -R system_u:object_r:httpd_sys_content_t:s0 /var/www/rhcert
chcon -R system_u:object_r:httpd_sys_rw_content_t:s0 /var/www/rhcert/store
chcon -R system_u:object_r:httpd_sys_script_exec_t:s0 /var/www/rhcert/wsgi
setsebool -P httpd_can_network_connect 1

%preun -n redhat-certification-backend
if pgrep "rhcertd" > /dev/null; then systemctl stop rhcertd.service; systemctl disable rhcertd.service; fi
systemctl daemon-reload
systemctl reset-failed

%files
%defattr(-,root,root)
/var/www/rhcert/application
/var/www/rhcert/css
/var/www/rhcert/fonts
/var/www/rhcert/images
/var/www/rhcert/img
/var/www/rhcert/js
/var/www/rhcert/project
/var/www/rhcert/templates
/var/www/rhcert/wsgi
/var/www/rhcert/xsl
# set to user apache for server/cgi serving
%attr(-, apache, apache) /var/www/rhcert/store
/etc/httpd/conf.d/rhcert.conf
/etc/httpd/conf.d/rhcert.pem


%files -n redhat-certification-backend
/usr/bin/rhcert-util
/usr/bin/rhcertd
/usr/bin/rhcert-ci
/usr/bin/rhcert-cli
%{?rhcert_sitelib}
%exclude %{?rhcert_sitelib}/suites/hwcert
%exclude %{?rhcert_sitelib}/suites/hwcertpreview
%exclude %{?rhcert_sitelib}/suites/cloud
%exclude %{?rhcert_sitelib}/suites/baremetal_cert
%exclude %{?rhcert_sitelib}/suites/openstack_cert
/etc/rhcert-default.xml
/etc/systemd/system/rhcertd.service

%files -n redhat-certification-hardware
%defattr(-,root,root,-)
%{rhcert_sitelib}/suites/hwcert

%files -n redhat-certification-hardware-preview
%defattr(-,root,root,-)
%{rhcert_sitelib}/suites/hwcertpreview

%files -n redhat-certification-cloud
%defattr(-,root,root,-)
%{rhcert_sitelib}/suites/cloud

%files -n redhat-certification-openstack
%defattr(-,root,root,-)
%{rhcert_sitelib}/suites/openstack_cert
%{_sysconfdir}/redhat-certification-openstack/tempest.conf.sample
%{_sysconfdir}/redhat-certification-openstack/test_config.json.sample

%files -n redhat-certification-baremetal
%{_sysconfdir}/redhat-certification-openstack/baremetal.json.sample

%defattr(-,root,root,-)
%{rhcert_sitelib}/suites/baremetal_cert

%changelog
